int led[6];
int relay[3];
int runmode;
int order;
unsigned long ltime;

void relaydrive(void);

void setup() {
  // put your setup code here, to run once:
  int i;

  for (i = 0; i < 6; i++){
    led[i] = 0;
  }
  led[0] = 1;

  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);  
  pinMode(5, INPUT);
  pinMode(6, INPUT);
  pinMode(7, INPUT);

  runmode = 0;
  order = 0;
  ltime = millis() + 500;
}

void loop() {
  // put your main code here, to run repeatedly:
  int iTemp;
  static int iLedDummy = 0;
  static int iTimeMode = 0;
  int iTime;

  if (runmode == 2){
    if (digitalRead(7) == HIGH){
      delay(1000);
      switch(iTimeMode){
        case 0:
          iTime = 500;
          break;
        case 1:
          iTime = 1000;
          break;
        case 2:
          iTime = 2000;
          break;
      }  

      switch(order){
        case 0:
          relay[0] = 0;
          relaydrive();
          delay(iTime);
          relay[1] = 0;
          relaydrive();
          delay(iTime);
          relay[2] = 0;
          relaydrive();
          delay(1000);
          break;
        case 1:
          relay[0] = 0;
          relaydrive();
          delay(iTime);
          relay[2] = 0;
          relaydrive();
          delay(iTime);
          relay[1] = 0;
          relaydrive();
          delay(1000);
          break;
        case 2:
          relay[1] = 0;
          relaydrive();
          delay(iTime);
          relay[0] = 0;
          relaydrive();
          delay(iTime);
          relay[2] = 0;
          relaydrive();
          delay(1000);
          break;
        case 3:
          relay[1] = 0;
          relaydrive();
          delay(iTime);
          relay[2] = 0;
          relaydrive();
          delay(iTime);
          relay[0] = 0;
          relaydrive();
          delay(1000);
          break;
        case 4:
          relay[2] = 0;
          relaydrive();
          delay(iTime);
          relay[0] = 0;
          relaydrive();
          delay(iTime);
          relay[1] = 0;
          relaydrive();
          delay(1000);
          break;
        case 5:
          relay[2] = 0;
          relaydrive();
          delay(iTime);
          relay[1] = 0;
          relaydrive();
          delay(iTime);
          relay[0] = 0;
          relaydrive();
          delay(1000);
          break;
     }
        
      led[0] = 1;
      led[1] = 0;
      led[2] = 0;
      iLedDummy = 0;
      runmode = 0;
      ltime = millis() + 500;
    }
  } else if (runmode == 1){
    switch(iTimeMode){
      case 0:
        iTime = 500;
        break;
      case 1:
        iTime = 1000;
        break;
      case 2:
        iTime = 2000;
        break;
    }  

    switch(order){
      case 0:
        relay[0] = 1;
        relaydrive();
        delay(iTime);
        relay[1] = 1;
        relaydrive();
        delay(iTime);
        relay[2] = 1;
        relaydrive();
        delay(1000);
        break;
      case 1:
        relay[0] = 1;
        relaydrive();
        delay(iTime);
        relay[2] = 1;
        relaydrive();
        delay(iTime);
        relay[1] = 1;
        relaydrive();
        delay(1000);
        break;
      case 2:
        relay[1] = 1;
        relaydrive();
        delay(iTime);
        relay[0] = 1;
        relaydrive();
        delay(iTime);
        relay[2] = 1;
        relaydrive();
        delay(1000);
        break;
      case 3:
        relay[1] = 1;
        relaydrive();
        delay(iTime);
        relay[2] = 1;
        relaydrive();
        delay(iTime);
        relay[0] = 1;
        relaydrive();
        delay(1000);
        break;
      case 4:
        relay[2] = 1;
        relaydrive();
        delay(iTime);
        relay[0] = 1;
        relaydrive();
        delay(iTime);
        relay[1] = 1;
        relaydrive();
        delay(1000);
        break;
      case 5:
        relay[2] = 1;
        relaydrive();
        delay(iTime);
        relay[1] = 1;
        relaydrive();
        delay(iTime);
        relay[0] = 1;
        relaydrive();
        delay(1000);
        break;
    }
      
    led[0] = 1;
    led[1] = 0;
    led[2] = 0;
    iLedDummy = 0;
    runmode = 2;
      
  } else {
    if (digitalRead(5) == HIGH){ // sw1
      if (order < 5) order++;
      else order = 0;
      pinMode(14, INPUT);
      pinMode(15, INPUT);
      pinMode(16, INPUT);
      pinMode(17, INPUT);
      pinMode(18, INPUT);
      delay(500);
    }
  
    if (digitalRead(6) == HIGH){ // sw2
      if (iTimeMode < 2) iTimeMode++;
      else iTimeMode = 0;
      pinMode(14, INPUT);
      pinMode(15, INPUT);
      pinMode(16, INPUT);
      pinMode(17, INPUT);
      pinMode(18, INPUT);
      delay(500);
    }

    if (digitalRead(7) == HIGH){ // sw3
      runmode = 1;
      pinMode(14, INPUT);
      pinMode(15, INPUT);
      pinMode(16, INPUT);
      pinMode(17, INPUT);
      pinMode(18, INPUT);
      delay(1000);
    }

    switch(iTimeMode){
      case 0:
        led[3] = 1;
        led[4] = 0;
        led[5] = 0;
        break;
      case 1:
        led[3] = 0;
        led[4] = 1;
        led[5] = 0;
        break;
      case 2:
        led[3] = 0;
        led[4] = 0;
        led[5] = 1;
        break;
      default:
        led[3] = 1;
        led[4] = 0;
        led[5] = 0;
        break;
    }
  
    displaydrive();
  
    relaydrive();

    if (ltime < millis()){
      ltime = millis() + 500;
      switch (order){
        case 0:
          iTemp = iLedDummy;
          iLedDummy = led[2];
          led[2] = led[1];
          led[1] = led[0];
          led[0] = iTemp;
          break;
        case 1:
          iTemp = iLedDummy;
          iLedDummy = led[1];
          led[1] = led[2];
          led[2] = led[0];
          led[0] = iTemp;
          break;
        case 2:
          iTemp = iLedDummy;
          iLedDummy = led[2];
          led[2] = led[0];
          led[0] = led[1];
          led[1] = iTemp;   
          break;
        case 3:
          iTemp = iLedDummy;
          iLedDummy = led[0];
          led[0] = led[2];
          led[2] = led[1];
          led[1] = iTemp;       
          break;
        case 4:
          iTemp = iLedDummy;
          iLedDummy = led[1];
          led[1] = led[0];
          led[0] = led[2];
          led[2] = iTemp;
          break;
        case 5:
          iTemp = iLedDummy;
          iLedDummy = led[0];
          led[0] = led[1];
          led[1] = led[2];
          led[2] = iTemp;
          break;
      }          
    }
  }
}


void displaydrive(){
  static int iLedNum;

  switch(iLedNum){
    case 0: // relay1
      if (led[0] == 1){
        pinMode(14, INPUT);
        pinMode(15, OUTPUT);
        digitalWrite(15, HIGH);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, OUTPUT);
        digitalWrite(18, LOW);
      } else {
        pinMode(14, INPUT);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      }
      break;
    case 1: // relay2
      if (led[1] == 1){
        pinMode(14, INPUT);
        pinMode(15, OUTPUT);
        digitalWrite(15, HIGH);
        pinMode(16, INPUT);
        pinMode(17, OUTPUT);
        digitalWrite(17, LOW);
        pinMode(18, INPUT);
      } else {
        pinMode(14, INPUT);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      }
      break;
    case 2: // relay3
      if (led[2] == 1){
        pinMode(14, INPUT);
        pinMode(15, OUTPUT);
        digitalWrite(15, HIGH);
        pinMode(16, OUTPUT);
        digitalWrite(16, LOW);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      } else {
        pinMode(14, INPUT);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      }
      break;
    case 3: // time1
      if (led[3] == 1){
        pinMode(14, OUTPUT);
        digitalWrite(14, HIGH);
        pinMode(15, INPUT);
        pinMode(16, OUTPUT);
        digitalWrite(16, LOW);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      } else {
        pinMode(14, INPUT);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      }
      break;
    case 4: // time2
      if (led[4] == 1){
        pinMode(14, OUTPUT);
        digitalWrite(14, HIGH);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, OUTPUT);
        digitalWrite(17, LOW);
        pinMode(18, INPUT);
      } else {
        pinMode(14, INPUT);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      }
      break;
    case 5: // time3
      if (led[5] == 1){
        pinMode(14, OUTPUT);
        digitalWrite(14, HIGH);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, OUTPUT);
        digitalWrite(18, LOW);
      } else {
        pinMode(14, INPUT);
        pinMode(15, INPUT);
        pinMode(16, INPUT);
        pinMode(17, INPUT);
        pinMode(18, INPUT);
      }
      break;
  }
  if (iLedNum < 5) iLedNum++;
  else iLedNum = 0;
}

void relaydrive(){
  if (relay[0]){
    digitalWrite(4, HIGH);
  } else {
    digitalWrite(4, LOW);
  }
  if (relay[1]){
    digitalWrite(3, HIGH);
  } else {
    digitalWrite(3, LOW);
  }
  if (relay[2]){
    digitalWrite(2, HIGH);
  } else {
    digitalWrite(2, LOW);
  }  
}

